Index: src/linkedcell.cpp
===================================================================
--- src/linkedcell.cpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/linkedcell.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /** \file linkedcell.cpp
  *
@@ -5,27 +12,52 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
 #include "atom.hpp"
-#include "helpers.hpp"
+#include "Helpers/helpers.hpp"
 #include "linkedcell.hpp"
-#include "verbose.hpp"
-#include "log.hpp"
+#include "Helpers/Verbose.hpp"
+#include "Helpers/Log.hpp"
 #include "molecule.hpp"
+#include "PointCloud.hpp"
 #include "tesselation.hpp"
-#include "vector.hpp"
+#include "LinearAlgebra/Vector.hpp"
 
 // ========================================================= class LinkedCell ===========================================
 
+/** Constructor for class LinkedCell::LinkedNodes.
+ */
+LinkedCell::LinkedNodes::LinkedNodes()
+{}
+
+/** Destructor for class LinkedCell::LinkedNodes.
+ */
+LinkedCell::LinkedNodes::~LinkedNodes()
+{}
+
+TesselPoint * LinkedCell::LinkedNodes::getValue (const_iterator &rhs) const
+{
+  return *rhs;
+}
+
+TesselPoint * LinkedCell::LinkedNodes::getValue (iterator &rhs) const
+{
+  return *rhs;
+}
 
 /** Constructor for class LinkedCell.
  */
-LinkedCell::LinkedCell()
-{
-  LC = NULL;
+LinkedCell::LinkedCell() :
+  LC(NULL),
+  RADIUS(0.),
+  index(-1)
+{
   for(int i=0;i<NDIM;i++)
     N[i] = 0;
-  index = -1;
-  RADIUS = 0.;
   max.Zero();
   min.Zero();
@@ -36,37 +68,37 @@
  * \param RADIUS edge length of cells
  */
-LinkedCell::LinkedCell(const PointCloud * const set, const double radius)
+LinkedCell::LinkedCell(const PointCloud & set, const double radius) :
+  LC(NULL),
+  RADIUS(radius),
+  index(-1)
 {
   TesselPoint *Walker = NULL;
 
-  RADIUS = radius;
-  LC = NULL;
   for(int i=0;i<NDIM;i++)
     N[i] = 0;
-  index = -1;
   max.Zero();
   min.Zero();
   DoLog(1) && (Log() << Verbose(1) << "Begin of LinkedCell" << endl);
-  if ((set == NULL) || (set->IsEmpty())) {
+  if (set.IsEmpty()) {
     DoeLog(1) && (eLog()<< Verbose(1) << "set is NULL or contains no linked cell nodes!" << endl);
     return;
   }
   // 1. find max and min per axis of atoms
-  set->GoToFirst();
-  Walker = set->GetPoint();
-  for (int i=0;i<NDIM;i++) {
-    max[i] = Walker->node->at(i);
-    min[i] = Walker->node->at(i);
-  }
-  set->GoToFirst();
-  while (!set->IsEnd()) {
-    Walker = set->GetPoint();
+  set.GoToFirst();
+  Walker = set.GetPoint();
+  for (int i=0;i<NDIM;i++) {
+    max[i] = Walker->at(i);
+    min[i] = Walker->at(i);
+  }
+  set.GoToFirst();
+  while (!set.IsEnd()) {
+    Walker = set.GetPoint();
     for (int i=0;i<NDIM;i++) {
-      if (max[i] < Walker->node->at(i))
-        max[i] = Walker->node->at(i);
-      if (min[i] > Walker->node->at(i))
-        min[i] = Walker->node->at(i);
+      if (max[i] < Walker->at(i))
+        max[i] = Walker->at(i);
+      if (min[i] > Walker->at(i))
+        min[i] = Walker->at(i);
     }
-    set->GoToNext();
+    set.GoToNext();
   }
   DoLog(2) && (Log() << Verbose(2) << "Bounding box is " << min << " and " << max << "." << endl);
@@ -84,4 +116,5 @@
     return;
   }
+  ASSERT(N[0]*N[1]*N[2] < MAX_LINKEDCELLNODES, "Number linked of linked cell nodes exceded hard-coded limit, use greater edge length!");
   LC = new LinkedNodes[N[0]*N[1]*N[2]];
   for (index=0;index<N[0]*N[1]*N[2];index++) {
@@ -92,14 +125,14 @@
   // 4. put each atom into its respective cell
   DoLog(2) && (Log() << Verbose(2) << "Filling cells ... ");
-  set->GoToFirst();
-  while (!set->IsEnd()) {
-    Walker = set->GetPoint();
+  set.GoToFirst();
+  while (!set.IsEnd()) {
+    Walker = set.GetPoint();
     for (int i=0;i<NDIM;i++) {
-      n[i] = static_cast<int>(floor((Walker->node->at(i) - min[i])/RADIUS));
+      n[i] = static_cast<int>(floor((Walker->at(i) - min[i])/RADIUS));
     }
     index = n[0] * N[1] * N[2] + n[1] * N[2] + n[2];
     LC[index].push_back(Walker);
     //Log() << Verbose(2) << *Walker << " goes into cell " << n[0] << ", " << n[1] << ", " << n[2] << " with No. " << index << "." << endl;
-    set->GoToNext();
+    set.GoToNext();
   }
   DoLog(0) && (Log() << Verbose(0) << "done."  << endl);
@@ -107,73 +140,4 @@
 };
 
-
-/** Puts all atoms in \a *mol into a linked cell list with cell's lengths of \a RADIUS
- * \param *set LCNodeSet class with all LCNode's
- * \param RADIUS edge length of cells
- */
-LinkedCell::LinkedCell(LinkedNodes *set, const double radius)
-{
-  class TesselPoint *Walker = NULL;
-  RADIUS = radius;
-  LC = NULL;
-  for(int i=0;i<NDIM;i++)
-    N[i] = 0;
-  index = -1;
-  max.Zero();
-  min.Zero();
-  DoLog(1) && (Log() << Verbose(1) << "Begin of LinkedCell" << endl);
-  if (set->empty()) {
-    DoeLog(1) && (eLog()<< Verbose(1) << "set contains no linked cell nodes!" << endl);
-    return;
-  }
-  // 1. find max and min per axis of atoms
-  LinkedNodes::iterator Runner = set->begin();
-  for (int i=0;i<NDIM;i++) {
-    max[i] = (*Runner)->node->at(i);
-    min[i] = (*Runner)->node->at(i);
-  }
-  for (LinkedNodes::iterator Runner = set->begin(); Runner != set->end(); Runner++) {
-    Walker = *Runner;
-    for (int i=0;i<NDIM;i++) {
-      if (max[i] < Walker->node->at(i))
-        max[i] = Walker->node->at(i);
-      if (min[i] > Walker->node->at(i))
-        min[i] = Walker->node->at(i);
-    }
-  }
-  DoLog(2) && (Log() << Verbose(2) << "Bounding box is " << min << " and " << max << "." << endl);
-
-  // 2. find then number of cells per axis
-  for (int i=0;i<NDIM;i++) {
-    N[i] = static_cast<int>(floor((max[i] - min[i])/RADIUS)+1);
-  }
-  DoLog(2) && (Log() << Verbose(2) << "Number of cells per axis are " << N[0] << ", " << N[1] << " and " << N[2] << "." << endl);
-
-  // 3. allocate the lists
-  DoLog(2) && (Log() << Verbose(2) << "Allocating cells ... ");
-  if (LC != NULL) {
-    DoeLog(1) && (eLog()<< Verbose(1) << "Linked Cell list is already allocated, I do nothing." << endl);
-    return;
-  }
-  LC = new LinkedNodes[N[0]*N[1]*N[2]];
-  for (index=0;index<N[0]*N[1]*N[2];index++) {
-    LC [index].clear();
-  }
-  DoLog(0) && (Log() << Verbose(0) << "done."  << endl);
-
-  // 4. put each atom into its respective cell
-  DoLog(2) && (Log() << Verbose(2) << "Filling cells ... ");
-  for (LinkedNodes::iterator Runner = set->begin(); Runner != set->end(); Runner++) {
-    Walker = *Runner;
-    for (int i=0;i<NDIM;i++) {
-      n[i] = static_cast<int>(floor((Walker->node->at(i) - min[i])/RADIUS));
-    }
-    index = n[0] * N[1] * N[2] + n[1] * N[2] + n[2];
-    LC[index].push_back(Walker);
-    //Log() << Verbose(2) << *Walker << " goes into cell " << n[0] << ", " << n[1] << ", " << n[2] << " with No. " << index << "." << endl;
-  }
-  DoLog(0) && (Log() << Verbose(0) << "done."  << endl);
-  DoLog(1) && (Log() << Verbose(1) << "End of LinkedCell" << endl);
-};
 
 /** Destructor for class LinkedCell.
@@ -248,8 +212,8 @@
  * \return Vector is inside bounding box - true, else - false
  */
-bool LinkedCell::SetIndexToVector(const Vector * const x) const
+bool LinkedCell::SetIndexToVector(const Vector & x) const
 {
   for (int i=0;i<NDIM;i++)
-    n[i] = (int)floor((x->at(i) - min[i])/RADIUS);
+    n[i] = (int)floor((x.at(i) - min[i])/RADIUS);
 
   return CheckBounds();
@@ -264,5 +228,5 @@
   bool status = false;
   for (int i=0;i<NDIM;i++) {
-    n[i] = static_cast<int>(floor((Walker->node->at(i) - min[i])/RADIUS));
+    n[i] = static_cast<int>(floor((Walker->at(i) - min[i])/RADIUS));
   }
   index = n[0] * N[1] * N[2] + n[1] * N[2] + n[2];
@@ -404,5 +368,5 @@
       Walker = *Runner;
       //Log() << Verbose(1) << "Current neighbour is at " << *Walker->node << "." << endl;
-      if ((center->DistanceSquared(*Walker->node) - radiusSquared) < MYEPSILON) {
+      if ((Walker->DistanceSquared(*center) - radiusSquared) < MYEPSILON) {
         TesselList->push_back(Walker);
       }
Index: src/linkedcell.hpp
===================================================================
--- src/linkedcell.hpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/linkedcell.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -22,7 +22,13 @@
 
 #include <list>
+#include <vector>
+#include <map>
 
+#include "Helpers/Assert.hpp"
+#include "Helpers/Log.hpp"
+#include "Helpers/Verbose.hpp"
 #include "defs.hpp"
-#include "vector.hpp"
+#include "World.hpp"
+#include "LinearAlgebra/Vector.hpp"
 
 /****************************************** forward declarations *****************************/
@@ -33,4 +39,6 @@
 /********************************************** definitions *********************************/
 
+//< Upper bound for number of cell nodes used in sensibility check on allocation.
+enum { MAX_LINKEDCELLNODES = 1000000 };
 
 /********************************************** declarations *******************************/
@@ -42,5 +50,13 @@
 
 public:
-  typedef list<TesselPoint *> LinkedNodes;
+  class LinkedNodes : public std::list<TesselPoint *> {
+  public:
+    LinkedNodes();
+    ~LinkedNodes();
+
+    TesselPoint * getValue (const_iterator &rhs) const;
+    TesselPoint * getValue (iterator &rhs) const;
+  };
+  //typedef list<TesselPoint *> LinkedNodes;
 
 
@@ -54,11 +70,77 @@
 
     LinkedCell();
-    LinkedCell(const  PointCloud * const set, const double RADIUS);
-    LinkedCell(LinkedNodes *set, const double radius);
+    LinkedCell(const PointCloud &set, const double radius);
+    template <class T> LinkedCell(const T &set, const double radius) :
+      LC(NULL),
+      RADIUS(radius),
+      index(-1)
+    {
+      class TesselPoint *Walker = NULL;
+      for(int i=0;i<NDIM;i++)
+        N[i] = 0;
+      max.Zero();
+      min.Zero();
+      DoLog(1) && (Log() << Verbose(1) << "Begin of LinkedCell" << endl);
+      if (set.begin() == set.end()) {
+        DoeLog(1) && (eLog()<< Verbose(1) << "set contains no linked cell nodes!" << endl);
+        return;
+      }
+      // 1. find max and min per axis of atoms
+      typename T::const_iterator Runner = set.begin();
+      for (int i=0;i<NDIM;i++) {
+        max[i] = set.getValue(Runner)->at(i);
+        min[i] = set.getValue(Runner)->at(i);
+      }
+      for (typename T::const_iterator Runner = set.begin(); Runner != set.end(); Runner++) {
+        Walker = set.getValue(Runner);
+        for (int i=0;i<NDIM;i++) {
+          if (max[i] < Walker->at(i))
+            max[i] = Walker->at(i);
+          if (min[i] > Walker->at(i))
+            min[i] = Walker->at(i);
+        }
+      }
+      DoLog(2) && (Log() << Verbose(2) << "Bounding box is " << min << " and " << max << "." << endl);
+
+      // 2. find then number of cells per axis
+      for (int i=0;i<NDIM;i++) {
+        N[i] = static_cast<int>(floor((max[i] - min[i])/RADIUS)+1);
+      }
+      DoLog(2) && (Log() << Verbose(2) << "Number of cells per axis are " << N[0] << ", " << N[1] << " and " << N[2] << "." << endl);
+
+      // 3. allocate the lists
+      DoLog(2) && (Log() << Verbose(2) << "Allocating cells ... ");
+      if (LC != NULL) {
+        DoeLog(1) && (eLog()<< Verbose(1) << "Linked Cell list is already allocated, I do nothing." << endl);
+        return;
+      }
+      ASSERT(N[0]*N[1]*N[2] < MAX_LINKEDCELLNODES, "Number linked of linked cell nodes exceded hard-coded limit, use greater edge length!");
+      LC = new LinkedNodes[N[0]*N[1]*N[2]];
+      for (index=0;index<N[0]*N[1]*N[2];index++) {
+        LC [index].clear();
+      }
+      DoLog(0) && (Log() << Verbose(0) << "done."  << endl);
+
+      // 4. put each atom into its respective cell
+      DoLog(2) && (Log() << Verbose(2) << "Filling cells ... ");
+      for (typename T::const_iterator Runner = set.begin(); Runner != set.end(); Runner++) {
+        Walker = set.getValue(Runner);
+        for (int i=0;i<NDIM;i++) {
+          n[i] = static_cast<int>(floor((Walker->at(i) - min[i])/RADIUS));
+        }
+        index = n[0] * N[1] * N[2] + n[1] * N[2] + n[2];
+        LC[index].push_back(Walker);
+        //Log() << Verbose(2) << *Walker << " goes into cell " << n[0] << ", " << n[1] << ", " << n[2] << " with No. " << index << "." << endl;
+      }
+      DoLog(0) && (Log() << Verbose(0) << "done."  << endl);
+      DoLog(1) && (Log() << Verbose(1) << "End of LinkedCell" << endl);
+    };
+
+
     ~LinkedCell();
     const LinkedCell::LinkedNodes* GetCurrentCell()const ;
     const LinkedCell::LinkedNodes* GetRelativeToCurrentCell(const int relative[NDIM])const ;
     bool SetIndexToNode(const TesselPoint * const Walker)const ;
-    bool SetIndexToVector(const Vector * const x)const ;
+    bool SetIndexToVector(const Vector &x)const ;
     double SetClosestIndexToOutsideVector(const Vector * const x) const;
     bool CheckBounds()const ;
